node default {

  if $osfamily == 'windows' {
    File { source_permissions => ignore }
    class { 'windows::power_scheme':
      ensure => 'High performance',
    }
  }

  ### User Settings

  $location_automotive_service_bus='X:/AutomotiveServiceBus'
  $zipfile_karaf_core_can_test_assembly="${location_automotive_service_bus}/carPC-assemblies/core-can-test-assembly/target/core-can-test-assembly-1.1.0.zip"
  $location_to_install_karaf_core_can_test_assemly='X:/AutomotiveServiceBus-karaf'

  $location_service_project='X:/biz.hochguertel.automotive.service.weather-parent'
  $location_maven_dot_m2='C:/Users/hochguertelto/.m2'

  ###

  if $osfamily == 'windows' {
    ps1template::unzip { $zipfile_karaf_core_can_test_assembly:
      destination => $location_to_install_karaf_core_can_test_assemly,
      extractpath => basename($zipfile_karaf_core_can_test_assembly, 'zip'),
      tempfolder  => 'X:\temp123',
      creates     => "${location_to_install_karaf_core_can_test_assemly}/bin/karaf.bat",
      require     => Ps1template::Exec['maven automotive service bus clean install'],
    }

    file { "${location_to_install_karaf_core_can_test_assemly}/etc/org.ops4j.pax.url.mvn.cfg":
      ensure  => present,
      source  => "${location_service_project}/puppet/org.ops4j.pax.url.mvn.cfg",
      require => Ps1template::Unzip[$zipfile_karaf_core_can_test_assembly],
    }

    file { "${location_to_install_karaf_core_can_test_assemly}/bin/setenv":
      ensure  => present,
      source  => "${location_service_project}/puppet/setenv",
      require => Ps1template::Unzip[$zipfile_karaf_core_can_test_assembly],
    }

    file { "${location_to_install_karaf_core_can_test_assemly}/bin/setenv.bat":
      ensure  => present,
      source  => "${location_service_project}/puppet/setenv.bat",
      require => Ps1template::Unzip[$zipfile_karaf_core_can_test_assembly],
    }

    file { "${location_to_install_karaf_core_can_test_assemly}/\${user.home}":
      ensure  => 'directory',
      require => Ps1template::Unzip[$zipfile_karaf_core_can_test_assembly],
    }
    file { "${location_to_install_karaf_core_can_test_assemly}/\${user.home}/.m2":
      ensure  => link,
      target  => $location_maven_dot_m2,
      require => File["${location_to_install_karaf_core_can_test_assemly}/\${user.home}"],
    }
    file { "C:/Windows/System32/\${user.home}":
      ensure            => 'directory',
    }
    file { "C:/Windows/System32/\${user.home}/.m2":
      ensure  => link,
      target  => $location_maven_dot_m2,
      require => File["C:/Windows/System32/\${user.home}"],
    }
  } # Windows Block

  ini_setting { 'karaf setting org.ops4j.pax.url.mvn.repositories':
    ensure            => present,
    path              => "${location_to_install_karaf_core_can_test_assemly}/etc/org.ops4j.pax.url.mvn.cfg",
    section           => '',
    key_val_separator => '=',
    setting           => 'org.ops4j.pax.url.mvn.repositories',
    value             => 'http://svn.apache.org/repos/asf/servicemix/m2-repo,http://repo1.maven.org/maven2@id=central,http://repository.springsource.com/maven/bundles/release@id=spring.ebr.release,http://repository.springsource.com/maven/bundles/external@id=spring.ebr.external,file:${karaf.home}/${karaf.default.repository}@id=system.repository,file:${karaf.data}/kar@id=kar.repository@multi',
    require           => File["${location_to_install_karaf_core_can_test_assemly}/etc/org.ops4j.pax.url.mvn.cfg"],
  }

  $tempfolder = 'C:/puppet-module-ps1template-exec-temp'

  file { $tempfolder:
    ensure            => 'directory',
  }

  ps1template::exec { 'maven automotive service bus clean install':
    command_template => 'exec/mvn clean install',
    creates          => $zipfile_karaf_core_can_test_assembly,
    cwd              => $location_automotive_service_bus,
    logoutput        => false,
    path             => $::path,
    tempfolder       => $tempfolder,
    require          => File[$tempfolder],
  }

  ps1template::exec { 'maven asb weather-service clean install':
    command_template => 'exec/mvn clean install',
    creates          => 'C:/Users/hochguertelto/.m2/repository/biz/hochguertel/automotive/service/weather',
    cwd              => 'X:/biz.hochguertel.automotive.service.weather-parent',
    logoutput        => true,
    path             => $::path,
    tempfolder       => $tempfolder,
    require          => File[$tempfolder],
  }

  # File: weather-parent\features\target\feature\feature.xml
  #     <repository>mvn:biz.hochguertel.automotive.service.weather/features/1.0.0-SNAPSHOT/xml/features</repository>
  # 
  #   ->  mvn:biz.hochguertel.automotive.service.weather/features/1.0.0-SNAPSHOT/xml/features

  # File: weather-parent\features\target\feature\feature.xml
  #     <feature name="weather" version="1.0.0-SNAPSHOT">
  # 
  #   ->  weather

  # Karaf Konsole:
  # 
  #   feature:repo-add mvn:biz.hochguertel.automotive.service.weather/features/1.0.0-SNAPSHOT/xml/features
  #   feature:install weather

  # Karaf Konsole:
  # 
  #   la

}
